#ifndef GENERAL_HPP
#define GENERAL_HPP

#include <iostream>
#include <list>
#include <ctime>
#include <cstdlib>
#include <cmath>

using namespace std;

/* Period parameterspour Mersenne twister */  
const int N = 624;
const int M = 397;
const long unsigned int MATRIX_A = 0x9908b0dfUL;   /* constant vector a */
const int UPPER_MASK = 0x80000000UL; /* most significant w-r bits */
const int LOWER_MASK = 0x7fffffffUL; /* least significant r bits */


typedef struct typeResultat
{
    long nbrLapinsVivants;
    long nbrLapinsMorts;
    long sommeNaissanceDeLapins;
}result_t;

 
////// Paramètres divers et variés : //////

const int NBREXECUTIONSPOURSTATISTIQUEFIABLE = 30;

const int NBRBEBESLAPINSINITIAUX = 7;
const int NBRMOISEXPERIENECE = 100;

// Taux de survie à la fin du mois en fonction de l'âge
const float IMMATURE = powf(0.35, 1.0/7.0); // je pars du principe que un lapin immature a 35% de chances d'avoir survivécu à la fin du 7ème mois
const float MATURE = powf(0.6, 1.0/12.0); // 60% de chances de ne pas mourir en 12 mois de vie en tant que lapin mature.
const float ONZIEMEANNEE = powf(0.5, 1.0/12.0); // 50% de chances de ne pas mourir en 12 mois de vie en tant que lapin ayant 10 ans et allant sur ses 11 ans...
const float DOUXIEMEANNEE = powf(0.4, 1.0/12.0); // etc...
const float TREIZIEMEANNEE = powf(0.3, 1.0/12.0);
const float QUATORZIEMEANNEE = powf(0.2, 1.0/12.0);
const float QUINZIEMEANNEE = powf(0.1, 1.0/12.0);
const float SEIZIEMEANNEE = powf(0.0, 1.0/12.0); // Le lapin meurt obligatoirement à la fin du premier mois de sa seixième année.

// Proba portée femelle mature en fin de mois 
const float PROBAPROCREATION = 0.25;

// Min et Max de petits par portée, équiprobable
const int MINPETITS = 3;
const int MAXPETITS = 6;

// Proba que le petit est une femelle
const float PROBASEXEFEMININ = 0.5;

// Proba du temps de (attention, il faut que la derniere valeur soit 1. Exemple : const double CINQMOIS = 0.15; const double SIXMOISOUMOINS = 0.5; const double SEPTMOISOUMOINS = 0.85; const double HUITMOISOUMOINS = 1.0;)
const double CINQMOIS = 0.15;
const double SIXMOISOUMOINS = 0.5;
const double SEPTMOISOUMOINS = 0.85;
const double HUITMOISOUMOINS = 1.0;


//idées pour plus de réalisme :

// Proportion minimale de mâles matures par rapport aux femelles matures pour assurer procréation. (en-dessous de cette proportion, aucune femelle n'a de portée ce mois).
//const float PROPORTIONMINMALES = 0.2; // minimum un mâle pour 5 femelles;

#endif